#include "cci_sos.h"
#include "err.h"
#include "cci_use.h"
sos_Object make_cci_Fun_object(cci_Fun x)
{  return sos_object_from_extern (&x,bcopy_from_cci_Fun,_cci_Fun_type); }
cci_Fun make_cci_Fun(sos_Object o)
{  cci_Fun x;
   sos_extern_from_object (&x,o,bcopy_to_cci_Fun,_cci_Fun_type);
   return x; }
_cci_Schema_impl* _cci_Schema_impl::_make(sos_Typed_id &tpid)
{  return (_cci_Schema_impl*)cci_Schema_impl::get_make_obj(_cci_Schema_impl_type,tpid.get_tp());
}
sos_Offset _cci_Schema_impl::_size(){return 20;}
void _cci_Schema_impl::_create(sos_Typed_id&_tpid){
   cci_Schema_impl _x=cci_Schema_impl::make(_tpid,this);
_cci_Schema_impl::local_initialize(_x);
}
void _cci_Schema_impl::_copy(sos_Typed_id&_tpid,cci_Schema_impl y){
   cci_Schema_impl x=cci_Schema_impl::make(_tpid,this);
_cci_Schema_impl::local_initialize(x);
}
sos_Object _cci_Schema_impl::_clone(sos_Typed_id&_tpid,sos_Container cnt){
   cci_Schema_impl _x=cci_Schema_impl::make(_tpid,this);
   return cci_Schema_impl::copy(_x,cnt);}
void _cci_Schema_impl::destroy(sos_Typed_id&_tpid){
   _cci_Schema_impl::local_finalize(cci_Schema_impl::make(_tpid,this));
   _tpid.container().deallocate(_tpid.offset(),20);}
void _cci_Schema_impl::assign(sos_Typed_id&_tpid,sos_Object o){
   cci_Schema_impl x=cci_Schema_impl::make(_tpid,this);
   _sos_Object::local_assign(x,o);
   _sos_Schema_impl::local_assign(x,o);
   _cci_Schema_impl::local_assign(x,o);
}
sos_Bool _cci_Schema_impl::equal(sos_Typed_id&_tpid,sos_Object o,sos_Eq_kind eq_kind){
   cci_Schema_impl x=cci_Schema_impl::make(_tpid,this);
   if (! _sos_Object::local_equal(x,o,eq_kind)) return FALSE;
   if (! _sos_Schema_impl::local_equal(x,o,eq_kind)) return FALSE;
   if (! _cci_Schema_impl::local_equal(x,o,eq_kind)) return FALSE;
   return TRUE;}
sos_Bool _cci_Schema_impl::local_equal(cci_Schema_impl x,sos_Object o,sos_Eq_kind eq_kind){
   if (eq_kind==EQ_STRONG) {if (!o.has_type(cci_Schema_impl_type)) return FALSE;}
   else if (!o.isa(cci_Schema_impl_type)) return FALSE;
   cci_Schema_impl y=cci_Schema_impl::make(o);
   return (sos_Bool)x.container().equal(x.offset()+x._ref->_offset_cci_Schema_impl(),12,y.container(),y.offset()+y._ref->_offset_cci_Schema_impl());}
sos_Int _cci_Schema_impl::hash_value(sos_Typed_id&_tpid){
   cci_Schema_impl x=cci_Schema_impl::make(_tpid,this);
   sos_Int result=0;
   result ^= _sos_Object::local_hash_value(x);
   result ^= _sos_Schema_impl::local_hash_value(x);
   result ^= _cci_Schema_impl::local_hash_value(x);
   return result;}
sos_Int _cci_Schema_impl::local_hash_value(cci_Schema_impl x){
   return x.container().hash_value(x.offset()+x._ref->_offset_cci_Schema_impl(),12);}
sos_String_List _cci_Schema_impl::get_object_files(sos_Typed_id&_tpid)
{  union {sos_Offset x; char c[4];} u; sos_Offset a;
   _tpid.container().read(_tpid.offset()+_offset_cci_Schema_impl()+0,4,&u);
   bcopy_to_sos_Offset(&a,&u);
   return sos_String_List::make(sos_make_local_typed_id(a,_tpid.container()));}
void _cci_Schema_impl::set_object_files(sos_Typed_id&_tpid,sos_String_List a){
   union {sos_Offset x; char c[4];} u;
   sos_Offset x=sos_local_offset(a,_tpid.container());
   bcopy_from_sos_Offset(&x,&u);
   _tpid.container().write(_tpid.offset() + _offset_cci_Schema_impl() + 0,4,&u);
}
sos_String_List _cci_Schema_impl::get_libraries(sos_Typed_id&_tpid)
{  union {sos_Offset x; char c[4];} u; sos_Offset a;
   _tpid.container().read(_tpid.offset()+_offset_cci_Schema_impl()+4,4,&u);
   bcopy_to_sos_Offset(&a,&u);
   return sos_String_List::make(sos_make_local_typed_id(a,_tpid.container()));}
void _cci_Schema_impl::set_libraries(sos_Typed_id&_tpid,sos_String_List a){
   union {sos_Offset x; char c[4];} u;
   sos_Offset x=sos_local_offset(a,_tpid.container());
   bcopy_from_sos_Offset(&x,&u);
   _tpid.container().write(_tpid.offset() + _offset_cci_Schema_impl() + 4,4,&u);
}
sos_String_List _cci_Schema_impl::get_schemas(sos_Typed_id&_tpid)
{  union {sos_Offset x; char c[4];} u; sos_Offset a;
   _tpid.container().read(_tpid.offset()+_offset_cci_Schema_impl()+8,4,&u);
   bcopy_to_sos_Offset(&a,&u);
   return sos_String_List::make(sos_make_local_typed_id(a,_tpid.container()));}
void _cci_Schema_impl::set_schemas(sos_Typed_id&_tpid,sos_String_List a){
   union {sos_Offset x; char c[4];} u;
   sos_Offset x=sos_local_offset(a,_tpid.container());
   bcopy_from_sos_Offset(&x,&u);
   _tpid.container().write(_tpid.offset() + _offset_cci_Schema_impl() + 8,4,&u);
}
static sos_Object _univ_6112440_24292(sos_Object o,sos_Object_Array){
   cci_Schema_impl::make (o).destroy();
   return NO_OBJECT;}
static sos_Object _univ_6112440_24356(sos_Object o,sos_Object_Array p){
   sos_Object o1=p[0];
   cci_Schema_impl::make (o).assign(sos_Object::make(o1));
   return NO_OBJECT;}
static sos_Object _univ_6112440_24420(sos_Object o,sos_Object_Array p){
   sos_Object o1=p[0], o2=p[1];
   return ::make_sos_Bool_object(cci_Schema_impl::make (o).equal(sos_Object::make(o1),::make_sos_Eq_kind(o2)));}
static sos_Object _univ_6112440_24484(sos_Object o,sos_Object_Array){
   return ::make_sos_Int_object(cci_Schema_impl::make (o).hash_value());}
static sos_Object _univ_6112440_24548(sos_Object o,sos_Object_Array){
   cci_Schema_impl::make (o).load();
   return NO_OBJECT;}
static void _init_meth_6112440_1704(){
   cci_Schema_impl::enter_fun(sos_Id::make(sos_Container::make(6112440),24292),(cci_Fun)_univ_6112440_24292);
   cci_Schema_impl::enter_fun(sos_Id::make(sos_Container::make(6112440),24356),(cci_Fun)_univ_6112440_24356);
   cci_Schema_impl::enter_fun(sos_Id::make(sos_Container::make(6112440),24420),(cci_Fun)_univ_6112440_24420);
   cci_Schema_impl::enter_fun(sos_Id::make(sos_Container::make(6112440),24484),(cci_Fun)_univ_6112440_24484);
   cci_Schema_impl::enter_fun(sos_Id::make(sos_Container::make(6112440),24548),(cci_Fun)_univ_6112440_24548);
}
static sos_Object _univ_6112440_24556(sos_Object o,sos_Object_Array){
   return sos_Object::make(cci_Schema_impl::make (o).get_object_files());}
static sos_Object _univ_6112440_24564(sos_Object o,sos_Object_Array p){
   sos_Object o1=p[0];
   cci_Schema_impl::make (o).set_object_files(sos_String_List::make(o1));
   return NO_OBJECT;}
static sos_Object _univ_6112440_24744(sos_Object o,sos_Object_Array){
   return sos_Object::make(cci_Schema_impl::make (o).get_libraries());}
static sos_Object _univ_6112440_24808(sos_Object o,sos_Object_Array p){
   sos_Object o1=p[0];
   cci_Schema_impl::make (o).set_libraries(sos_String_List::make(o1));
   return NO_OBJECT;}
static sos_Object _univ_6112440_24872(sos_Object o,sos_Object_Array){
   return sos_Object::make(cci_Schema_impl::make (o).get_schemas());}
static sos_Object _univ_6112440_24936(sos_Object o,sos_Object_Array p){
   sos_Object o1=p[0];
   cci_Schema_impl::make (o).set_schemas(sos_String_List::make(o1));
   return NO_OBJECT;}
static void _init_comp_6112440_1704(){
   cci_Schema_impl::enter_fun(sos_Id::make(sos_Container::make(6112440),24556),(cci_Fun)_univ_6112440_24556);
   cci_Schema_impl::enter_fun(sos_Id::make(sos_Container::make(6112440),24564),(cci_Fun)_univ_6112440_24564);
   cci_Schema_impl::enter_fun(sos_Id::make(sos_Container::make(6112440),24744),(cci_Fun)_univ_6112440_24744);
   cci_Schema_impl::enter_fun(sos_Id::make(sos_Container::make(6112440),24808),(cci_Fun)_univ_6112440_24808);
   cci_Schema_impl::enter_fun(sos_Id::make(sos_Container::make(6112440),24872),(cci_Fun)_univ_6112440_24872);
   cci_Schema_impl::enter_fun(sos_Id::make(sos_Container::make(6112440),24936),(cci_Fun)_univ_6112440_24936);
}
static sos_Object _univ_6112440_25000(sos_Object,sos_Object_Array p){
   sos_Object o1=p[0];
   return sos_Object::make(cci_Schema_impl::create(::make_sos_Container(o1)));}
static sos_Object _univ_6112440_25064(sos_Object,sos_Object_Array p){
   sos_Object o1=p[0], o2=p[1];
   return sos_Object::make(cci_Schema_impl::copy(cci_Schema_impl::make(o1),::make_sos_Container(o2)));}
static sos_Object _univ_6112440_25128(sos_Object,sos_Object_Array p){
   sos_Object o1=p[0], o2=p[1];
   return sos_Object::make(cci_Schema_impl::clone(cci_Schema_impl::make(o1),::make_sos_Container(o2)));}
static sos_Object _univ_6112440_25192(sos_Object,sos_Object_Array p){
   sos_Object o1=p[0];
   return sos_Object::make(cci_Schema_impl::make_impl(sos_Schema_module::make(o1)));}
static sos_Object _univ_6112440_25256(sos_Object,sos_Object_Array p){
   sos_Object o1=p[0], o2=p[1];
   return ::make_cci_Make_obj_object(cci_Schema_impl::get_make_obj(::make_sos_Id(o1),::make_sos_Id(o2)));}
static sos_Object _univ_6112440_25320(sos_Object,sos_Object_Array p){
   sos_Object o1=p[0], o2=p[1], o3=p[2];
   cci_Schema_impl::enter_make_obj(::make_sos_Id(o1),::make_sos_Id(o2),::make_sos_Pointer(o3));
   return NO_OBJECT;}
static sos_Object _univ_6112440_25384(sos_Object,sos_Object_Array p){
   sos_Object o1=p[0];
   return ::make_cci_Fun_object(cci_Schema_impl::get_fun(::make_sos_Id(o1)));}
static sos_Object _univ_6112440_25448(sos_Object,sos_Object_Array p){
   sos_Object o1=p[0], o2=p[1];
   cci_Schema_impl::enter_fun(::make_sos_Id(o1),::make_cci_Fun(o2));
   return NO_OBJECT;}
static sos_Object _univ_6112440_25512(sos_Object,sos_Object_Array p){
   sos_Object o1=p[0], o2=p[1], o3=p[2];
   cci_Schema_impl::enter_string_io(::make_sos_Id(o1),::make_sos_Pointer(o2),::make_sos_Pointer(o3));
   return NO_OBJECT;}
static sos_Object _univ_6112440_25576(sos_Object,sos_Object_Array p){
   sos_Object o1=p[0], o2=p[1];
   return sos_Object::make(cci_Schema_impl::extern_object_from_string(sos_Type::make(o1),sos_String::make(o2)));}
static sos_Object _univ_6112440_25584(sos_Object,sos_Object_Array p){
   sos_Object o1=p[0];
   return sos_Object::make(cci_Schema_impl::string_from_extern_object(sos_Object::make(o1)));}
static void _init_stat_6112440_1704(){
   cci_Schema_impl::enter_fun(sos_Id::make(sos_Container::make(6112440),25000),(cci_Fun)_univ_6112440_25000);
   cci_Schema_impl::enter_fun(sos_Id::make(sos_Container::make(6112440),25064),(cci_Fun)_univ_6112440_25064);
   cci_Schema_impl::enter_fun(sos_Id::make(sos_Container::make(6112440),25128),(cci_Fun)_univ_6112440_25128);
   cci_Schema_impl::enter_fun(sos_Id::make(sos_Container::make(6112440),25192),(cci_Fun)_univ_6112440_25192);
   cci_Schema_impl::enter_fun(sos_Id::make(sos_Container::make(6112440),25256),(cci_Fun)_univ_6112440_25256);
   cci_Schema_impl::enter_fun(sos_Id::make(sos_Container::make(6112440),25320),(cci_Fun)_univ_6112440_25320);
   cci_Schema_impl::enter_fun(sos_Id::make(sos_Container::make(6112440),25384),(cci_Fun)_univ_6112440_25384);
   cci_Schema_impl::enter_fun(sos_Id::make(sos_Container::make(6112440),25448),(cci_Fun)_univ_6112440_25448);
   cci_Schema_impl::enter_fun(sos_Id::make(sos_Container::make(6112440),25512),(cci_Fun)_univ_6112440_25512);
   cci_Schema_impl::enter_fun(sos_Id::make(sos_Container::make(6112440),25576),(cci_Fun)_univ_6112440_25576);
   cci_Schema_impl::enter_fun(sos_Id::make(sos_Container::make(6112440),25584),(cci_Fun)_univ_6112440_25584);
}
_cci_Schema_impl *__cci_Schema_impl_obj;
static void _init_new_6112440_1704(){
   cci_Schema_impl::enter_make_obj(_sos_Object_type,_cci_Schema_impl_type,(_sos_Object*)__cci_Schema_impl_obj);
   cci_Schema_impl::enter_make_obj(_sos_Schema_impl_type,_cci_Schema_impl_type,(_sos_Schema_impl*)__cci_Schema_impl_obj);
   cci_Schema_impl::enter_make_obj(_cci_Schema_impl_type,_cci_Schema_impl_type,(_cci_Schema_impl*)__cci_Schema_impl_obj);
}
cci_Schema_impl::operator sos_Object(){return(sos_Object::make(_tpid,_ref));}
cci_Schema_impl::operator sos_Schema_impl(){return(sos_Schema_impl::make(_tpid,_ref));}
cci_Schema_impl cci_Schema_impl::make(sos_Typed_id&p){
   cci_Schema_impl o; o._tpid=p;
   o._ref=_cci_Schema_impl::_make(p); return o;}
cci_Schema_impl cci_Schema_impl::make(sos_Root_class& o){return cci_Schema_impl::make(o.typed_id());}
   sos_Offset cci_Schema_impl::_size(){return _ref->_size();}
cci_Schema_impl cci_Schema_impl::create(sos_Container _cnt){
   cci_Schema_impl _x=cci_Schema_impl::make(sos_Typed_id::allocate(cci_Schema_impl_type,_cnt,20));
   _x._ref->_create(_x._tpid);
   return _x;
}
cci_Schema_impl cci_Schema_impl::copy(cci_Schema_impl y,sos_Container cnt){
   cci_Schema_impl x=cci_Schema_impl::make(sos_Typed_id::allocate(cci_Schema_impl_type,cnt,20));
   x._ref->_copy(x._tpid,y);
   x.assign(y);
   return x;
}
cci_Schema_impl cci_Schema_impl::clone(cci_Schema_impl o,sos_Container cnt){
   return cci_Schema_impl::make (o._ref->_clone(o._tpid,cnt));
}
void cci_Schema_impl::destroy(){(_ref->destroy(_tpid));}
sos_Int cci_Schema_impl::hash_value(){return (_ref->hash_value(_tpid));}
void cci_Schema_impl::load(){(_ref->load(_tpid));}
sos_String_List cci_Schema_impl::get_libraries(){return (_ref->get_libraries(_tpid));}
void cci_Schema_impl::set_libraries(sos_String_List _p1){(_ref->set_libraries(_tpid,_p1));}
sos_String_List cci_Schema_impl::get_schemas(){return (_ref->get_schemas(_tpid));}
void cci_Schema_impl::set_schemas(sos_String_List _p1){(_ref->set_schemas(_tpid,_p1));}
cci_Make_obj cci_Schema_impl::get_make_obj(sos_Id _p1,sos_Id _p2){return (_cci_Schema_impl::get_make_obj(_p1,_p2));}
void cci_Schema_impl::enter_fun(sos_Id _p1,cci_Fun _p2){(_cci_Schema_impl::enter_fun(_p1,_p2));}
void cci_Schema_impl::enter_string_io(sos_Id _p1,cci_IO_fun _p2,cci_IO_fun _p3){(_cci_Schema_impl::enter_string_io(_p1,_p2,_p3));}
sos_Object cci_Schema_impl::extern_object_from_string(sos_Type _p1,sos_String _p2){return (_cci_Schema_impl::extern_object_from_string(_p1,_p2));}
void cci_Schema_impl::local_assign(cci_Schema_impl _p1,sos_Object _p2){(_cci_Schema_impl::local_assign(_p1,_p2));}
sos_Bool cci_Schema_impl::has_type(sos_Type _p1){return (_ref->has_type(_tpid,_p1));}
sos_Bool cci_Schema_impl::isa(sos_Type _p1){return (_ref->isa(_tpid,_p1));}
sos_Bool cci_Schema_impl::operator==(sos_Object _p1){return (_ref->__equal(_tpid,_p1));}
sos_Bool cci_Schema_impl::operator!=(sos_Object _p1){return (_ref->__not_equal(_tpid,_p1));}
sos_Bool cci_Schema_impl::local_equal(cci_Schema_impl x,cci_Schema_impl y,sos_Eq_kind eq_kind){return (_cci_Schema_impl::local_equal(x,y,eq_kind));}
void cci_Schema_impl::assign(sos_Object source){(_ref->assign(_tpid,source));}
sos_Bool cci_Schema_impl::equal(sos_Object o,sos_Eq_kind eq_kind){return (_ref->equal(_tpid,o,eq_kind));}
sos_String_List cci_Schema_impl::get_object_files(){return (_ref->get_object_files(_tpid));}
void cci_Schema_impl::set_object_files(sos_String_List _p1){(_ref->set_object_files(_tpid,_p1));}
cci_Schema_impl cci_Schema_impl::make_impl(sos_Schema_module _p1){return (_cci_Schema_impl::make_impl(_p1));}
void cci_Schema_impl::enter_make_obj(sos_Id _p1,sos_Id _p2,cci_Make_obj _p3){(_cci_Schema_impl::enter_make_obj(_p1,_p2,_p3));}
cci_Fun cci_Schema_impl::get_fun(sos_Id _p1){return (_cci_Schema_impl::get_fun(_p1));}
sos_String cci_Schema_impl::string_from_extern_object(sos_Object _p1){return (_cci_Schema_impl::string_from_extern_object(_p1));}
void cci_Schema_impl::local_initialize(cci_Schema_impl _p1){(_cci_Schema_impl::local_initialize(_p1));}
void cci_Schema_impl::local_finalize(cci_Schema_impl _p1){(_cci_Schema_impl::local_finalize(_p1));}
sos_Type cci_Schema_impl::type(){return (_ref->type(_tpid));}
sos_Bool cci_Schema_impl::is_some(sos_Type _p1){return (_ref->is_some(_tpid,_p1));}
sos_Bool cci_Schema_impl::is_value(){return (_ref->is_value(_tpid));}
sos_Int cci_Schema_impl::size(){return (_ref->size(_tpid));}
sos_Bool cci_Schema_impl::identical(sos_Object _p1){return (_ref->identical(_tpid,_p1));}
sos_Bool cci_Schema_impl::like(sos_Object _p1){return (_ref->like(_tpid,_p1));}
sos_Comp_result cci_Schema_impl::compare_ids(sos_Object _p1){return (_ref->compare_ids(_tpid,_p1));}
sos_Int cci_Schema_impl::local_hash_value(cci_Schema_impl x){return (_cci_Schema_impl::local_hash_value(x));}
_cci_Method_impl* _cci_Method_impl::_make(sos_Typed_id &tpid)
{  return (_cci_Method_impl*)cci_Schema_impl::get_make_obj(_cci_Method_impl_type,tpid.get_tp());
}
sos_Offset _cci_Method_impl::_size(){return 8;}
void _cci_Method_impl::_create(sos_Typed_id&_tpid){
   cci_Method_impl _x=cci_Method_impl::make(_tpid,this);
}
void _cci_Method_impl::_copy(sos_Typed_id&_tpid,cci_Method_impl y){
   cci_Method_impl x=cci_Method_impl::make(_tpid,this);
}
sos_Object _cci_Method_impl::_clone(sos_Typed_id&_tpid,sos_Container cnt){
   cci_Method_impl _x=cci_Method_impl::make(_tpid,this);
   return cci_Method_impl::copy(_x,cnt);}
void _cci_Method_impl::destroy(sos_Typed_id&_tpid){
   _tpid.container().deallocate(_tpid.offset(),8);}
void _cci_Method_impl::assign(sos_Typed_id&_tpid,sos_Object o){
   cci_Method_impl x=cci_Method_impl::make(_tpid,this);
   _sos_Object::local_assign(x,o);
   _sos_Method_impl::local_assign(x,o);
   _cci_Method_impl::local_assign(x,o);
}
void _cci_Method_impl::local_assign(cci_Method_impl x,sos_Object o){
}
sos_Bool _cci_Method_impl::equal(sos_Typed_id&_tpid,sos_Object o,sos_Eq_kind eq_kind){
   cci_Method_impl x=cci_Method_impl::make(_tpid,this);
   if (! _sos_Object::local_equal(x,o,eq_kind)) return FALSE;
   if (! _sos_Method_impl::local_equal(x,o,eq_kind)) return FALSE;
   if (! _cci_Method_impl::local_equal(x,o,eq_kind)) return FALSE;
   return TRUE;}
sos_Bool _cci_Method_impl::local_equal(cci_Method_impl,sos_Object,sos_Eq_kind) { return TRUE;}
sos_Int _cci_Method_impl::hash_value(sos_Typed_id&_tpid){
   cci_Method_impl x=cci_Method_impl::make(_tpid,this);
   sos_Int result=0;
   result ^= _sos_Object::local_hash_value(x);
   result ^= _sos_Method_impl::local_hash_value(x);
   result ^= _cci_Method_impl::local_hash_value(x);
   return result;}
sos_Int _cci_Method_impl::local_hash_value(cci_Method_impl x){
   return x.container().hash_value(x.offset()+x._ref->_offset_cci_Method_impl(),0);}
static sos_Object _univ_6112440_26024(sos_Object o,sos_Object_Array){
   cci_Method_impl::make (o).destroy();
   return NO_OBJECT;}
static sos_Object _univ_6112440_26088(sos_Object o,sos_Object_Array p){
   sos_Object o1=p[0];
   cci_Method_impl::make (o).assign(sos_Object::make(o1));
   return NO_OBJECT;}
static sos_Object _univ_6112440_26152(sos_Object o,sos_Object_Array p){
   sos_Object o1=p[0], o2=p[1];
   return ::make_sos_Bool_object(cci_Method_impl::make (o).equal(sos_Object::make(o1),::make_sos_Eq_kind(o2)));}
static sos_Object _univ_6112440_26216(sos_Object o,sos_Object_Array){
   return ::make_sos_Int_object(cci_Method_impl::make (o).hash_value());}
static sos_Object _univ_6112440_26280(sos_Object o,sos_Object_Array p){
   sos_Object o1=p[0];
   cci_Method_impl::make (o).enter_fun(::make_cci_Fun(o1));
   return NO_OBJECT;}
static sos_Object _univ_6112440_26344(sos_Object o,sos_Object_Array p){
   sos_Object o1=p[0], o2=p[1];
   return sos_Object::make(cci_Method_impl::make (o).execute(sos_Object::make(o1),sos_Object_Array::make(o2)));}
static void _init_meth_6112440_16384(){
   cci_Schema_impl::enter_fun(sos_Id::make(sos_Container::make(6112440),26024),(cci_Fun)_univ_6112440_26024);
   cci_Schema_impl::enter_fun(sos_Id::make(sos_Container::make(6112440),26088),(cci_Fun)_univ_6112440_26088);
   cci_Schema_impl::enter_fun(sos_Id::make(sos_Container::make(6112440),26152),(cci_Fun)_univ_6112440_26152);
   cci_Schema_impl::enter_fun(sos_Id::make(sos_Container::make(6112440),26216),(cci_Fun)_univ_6112440_26216);
   cci_Schema_impl::enter_fun(sos_Id::make(sos_Container::make(6112440),26280),(cci_Fun)_univ_6112440_26280);
   cci_Schema_impl::enter_fun(sos_Id::make(sos_Container::make(6112440),26344),(cci_Fun)_univ_6112440_26344);
}
static void _init_comp_6112440_16384(){
}
static sos_Object _univ_6112440_26408(sos_Object,sos_Object_Array p){
   sos_Object o1=p[0];
   return sos_Object::make(cci_Method_impl::create(::make_sos_Container(o1)));}
static sos_Object _univ_6112440_26472(sos_Object,sos_Object_Array p){
   sos_Object o1=p[0], o2=p[1];
   return sos_Object::make(cci_Method_impl::copy(cci_Method_impl::make(o1),::make_sos_Container(o2)));}
static sos_Object _univ_6112440_26536(sos_Object,sos_Object_Array p){
   sos_Object o1=p[0], o2=p[1];
   return sos_Object::make(cci_Method_impl::clone(cci_Method_impl::make(o1),::make_sos_Container(o2)));}
static sos_Object _univ_6112440_26600(sos_Object,sos_Object_Array p){
   sos_Object o1=p[0];
   return sos_Object::make(cci_Method_impl::operator_string(sos_String::make(o1)));}
static sos_Object _univ_6112440_26608(sos_Object,sos_Object_Array p){
   sos_Object o1=p[0];
   return sos_Object::make(cci_Method_impl::make_impl(sos_Method::make(o1)));}
static void _init_stat_6112440_16384(){
   cci_Schema_impl::enter_fun(sos_Id::make(sos_Container::make(6112440),26408),(cci_Fun)_univ_6112440_26408);
   cci_Schema_impl::enter_fun(sos_Id::make(sos_Container::make(6112440),26472),(cci_Fun)_univ_6112440_26472);
   cci_Schema_impl::enter_fun(sos_Id::make(sos_Container::make(6112440),26536),(cci_Fun)_univ_6112440_26536);
   cci_Schema_impl::enter_fun(sos_Id::make(sos_Container::make(6112440),26600),(cci_Fun)_univ_6112440_26600);
   cci_Schema_impl::enter_fun(sos_Id::make(sos_Container::make(6112440),26608),(cci_Fun)_univ_6112440_26608);
}
_cci_Method_impl *__cci_Method_impl_obj;
static void _init_new_6112440_16384(){
   cci_Schema_impl::enter_make_obj(_sos_Object_type,_cci_Method_impl_type,(_sos_Object*)__cci_Method_impl_obj);
   cci_Schema_impl::enter_make_obj(_sos_Method_impl_type,_cci_Method_impl_type,(_sos_Method_impl*)__cci_Method_impl_obj);
   cci_Schema_impl::enter_make_obj(_cci_Method_impl_type,_cci_Method_impl_type,(_cci_Method_impl*)__cci_Method_impl_obj);
}
cci_Method_impl::operator sos_Object(){return(sos_Object::make(_tpid,_ref));}
cci_Method_impl::operator sos_Method_impl(){return(sos_Method_impl::make(_tpid,_ref));}
cci_Method_impl cci_Method_impl::make(sos_Typed_id&p){
   cci_Method_impl o; o._tpid=p;
   o._ref=_cci_Method_impl::_make(p); return o;}
cci_Method_impl cci_Method_impl::make(sos_Root_class& o){return cci_Method_impl::make(o.typed_id());}
   sos_Offset cci_Method_impl::_size(){return _ref->_size();}
cci_Method_impl cci_Method_impl::create(sos_Container _cnt){
   cci_Method_impl _x=cci_Method_impl::make(sos_Typed_id::allocate(cci_Method_impl_type,_cnt,8));
   _x._ref->_create(_x._tpid);
   return _x;
}
cci_Method_impl cci_Method_impl::copy(cci_Method_impl y,sos_Container cnt){
   cci_Method_impl x=cci_Method_impl::make(sos_Typed_id::allocate(cci_Method_impl_type,cnt,8));
   x._ref->_copy(x._tpid,y);
   x.assign(y);
   return x;
}
cci_Method_impl cci_Method_impl::clone(cci_Method_impl o,sos_Container cnt){
   return cci_Method_impl::make (o._ref->_clone(o._tpid,cnt));
}
void cci_Method_impl::destroy(){(_ref->destroy(_tpid));}
void cci_Method_impl::assign(sos_Object source){(_ref->assign(_tpid,source));}
sos_Bool cci_Method_impl::equal(sos_Object o,sos_Eq_kind eq_kind){return (_ref->equal(_tpid,o,eq_kind));}
sos_Int cci_Method_impl::hash_value(){return (_ref->hash_value(_tpid));}
void cci_Method_impl::enter_fun(cci_Fun _p1){(_ref->enter_fun(_tpid,_p1));}
sos_Object cci_Method_impl::execute(sos_Object _p1,sos_Object_Array _p2){return (_ref->execute(_tpid,_p1,_p2));}
sos_String cci_Method_impl::operator_string(sos_String _p1){return (_cci_Method_impl::operator_string(_p1));}
cci_Method_impl cci_Method_impl::make_impl(sos_Method _p1){return (_cci_Method_impl::make_impl(_p1));}
sos_Type cci_Method_impl::type(){return (_ref->type(_tpid));}
sos_Bool cci_Method_impl::has_type(sos_Type _p1){return (_ref->has_type(_tpid,_p1));}
sos_Bool cci_Method_impl::isa(sos_Type _p1){return (_ref->isa(_tpid,_p1));}
sos_Bool cci_Method_impl::is_some(sos_Type _p1){return (_ref->is_some(_tpid,_p1));}
sos_Bool cci_Method_impl::is_value(){return (_ref->is_value(_tpid));}
sos_Int cci_Method_impl::size(){return (_ref->size(_tpid));}
sos_Bool cci_Method_impl::identical(sos_Object _p1){return (_ref->identical(_tpid,_p1));}
sos_Bool cci_Method_impl::operator==(sos_Object _p1){return (_ref->__equal(_tpid,_p1));}
sos_Bool cci_Method_impl::operator!=(sos_Object _p1){return (_ref->__not_equal(_tpid,_p1));}
sos_Bool cci_Method_impl::like(sos_Object _p1){return (_ref->like(_tpid,_p1));}
sos_Comp_result cci_Method_impl::compare_ids(sos_Object _p1){return (_ref->compare_ids(_tpid,_p1));}
void cci_Method_impl::local_assign(cci_Method_impl x,cci_Method_impl y){(_cci_Method_impl::local_assign(x,y));}
sos_Bool cci_Method_impl::local_equal(cci_Method_impl x,cci_Method_impl y,sos_Eq_kind eq_kind){return (_cci_Method_impl::local_equal(x,y,eq_kind));}
sos_Int cci_Method_impl::local_hash_value(cci_Method_impl x){return (_cci_Method_impl::local_hash_value(x));}
static struct _sos_init_dummy {
   _sos_init_dummy() {_cci_init_sos();}   ~_sos_init_dummy(){}
   } _sos_dummy;
static int _sos_initialized=0;
void _cci_init_sos(){
   if (_sos_initialized) return;
   _sos_initialized=1;
   _knl_init_sos();
   _agg_init_sos();
   _mta_init_sos();
   cci_Schema_impl::enter_make_obj(_sos_Object_type,_cci_Fun_type,(_sos_Object*) new _sos_Scalar_object);
   cci_Schema_impl::enter_make_obj(_sos_Scalar_object_type,_cci_Fun_type,(_sos_Scalar_object*) new _sos_Scalar_object);
   cci_Schema_impl::enter_string_io (_cci_Fun_type,(cci_IO_fun)make_string_from_cci_Fun_object,(cci_IO_fun)make_cci_Fun_object_from_string);
   __cci_Schema_impl_obj=new _cci_Schema_impl;
   _init_meth_6112440_1704();
   _init_comp_6112440_1704();
   _init_stat_6112440_1704();
   _init_new_6112440_1704();
   __cci_Method_impl_obj=new _cci_Method_impl;
   _init_meth_6112440_16384();
   _init_comp_6112440_16384();
   _init_stat_6112440_16384();
   _init_new_6112440_16384();
}
