/* --------------------------------------------------------------------------
 * Copyright 1992 by Forschungszentrum Informatik (FZI)
 *
 * You can use and distribute this software under the terms of the licence
 * you should have received along with this program.
 * If not or if you want additional information, write to
 * Forschungszentrum Informatik, "STONE", Haid-und-Neu-Strasse 10-14,
 * D-7500 Karlsruhe 1, Germany.
 * --------------------------------------------------------------------------
 */
#include "sys.h"
#include "sos.h"
#include "cci_use.h"

const char *ENVVAR_NAME = "SOSTMPDIR";
const char *DEFAULT_DIR = ".";

const char *sos_tempdir = DEFAULT_DIR;

void sos_init (int, char *argv[])
{  sos_tempdir = getenv (ENVVAR_NAME);
   sos_tempdir = (sos_tempdir) ? strdup (sos_tempdir)
			       : DEFAULT_DIR;

   cci_init (argv);
}
